/*
 * 开团黑名单
 */

using System;
using System.Web;
using System.Collections.Generic;
using System.Diagnostics;
using System.Linq;
using System.Threading.Tasks;
using Microsoft.AspNetCore.Mvc;
using Microsoft.AspNetCore.Http;
using Microsoft.Extensions.Logging;
using Microsoft.Extensions.Options;
using MySystem.Models;
using Library;
using LitJson;
using MySystemLib;

namespace MySystem.Areas.Admin.Controllers
{
    [Area("Admin")]
    [Route("Admin/[controller]/[action]")]
    public class TeamBlackListController : BaseController
    {
        public TeamBlackListController(IHttpContextAccessor accessor, ILogger<BaseController> logger, IOptions<Setting> setting) : base(accessor, logger, setting)
        {
            OtherMySqlConn.connstr = ConfigurationManager.AppSettings["SqlConnStr"].ToString();
        }

        #region 开团黑名单列表

        /// <summary>
        /// 根据条件查询开团黑名单列表
        /// </summary>
        /// <returns></returns>
        public IActionResult Index(TeamBlackList data, string right)
        {
            ViewBag.RightInfo = RightInfo;
            ViewBag.right = right;

            return View();
        }

        #endregion

        #region 根据条件查询开团黑名单列表

        /// <summary>
        /// 开团黑名单列表
        /// </summary>
        /// <returns></returns>
        public JsonResult IndexData(TeamBlackList data, string UserIdMakerCode, string UserIdRealName, string TopUserIdMakerCode, string TopUserIdRealName, string BlackStatusSelect, int page = 1, int limit = 30)
        {

            Dictionary<string, string> Fields = new Dictionary<string, string>();

            Fields.Add("CreateDate", "3"); //时间
            Fields.Add("EffectStartDate", "3"); //生效时间


            string condition = " and Status>-1";
            //创客编号
            if (!string.IsNullOrEmpty(UserIdMakerCode))
            {
                condition += " and UserId in (select UserId from UserForMakerCode where MakerCode='" + UserIdMakerCode + "')";
            }
            //创客真实姓名
            if (!string.IsNullOrEmpty(UserIdRealName))
            {
                condition += " and UserId in (select UserId from UserForRealName where RealName='" + UserIdRealName + "')";
            }
            //顶级创客编号
            if (!string.IsNullOrEmpty(TopUserIdMakerCode))
            {
                condition += " and TopUserId in (select TopUserId from UserForMakerCode where MakerCode='" + TopUserIdMakerCode + "')";
            }
            //顶级创客真实姓名
            if (!string.IsNullOrEmpty(TopUserIdRealName))
            {
                condition += " and TopUserId in (select TopUserId from UserForRealName where RealName='" + TopUserIdRealName + "')";
            }
            //状态
            if (!string.IsNullOrEmpty(BlackStatusSelect))
            {
                condition += " and BlackStatus=" + BlackStatusSelect;
            }

            Dictionary<string, object> obj = new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).IndexData("TeamBlackList", Fields, "Id desc", "0", page, limit, condition);
            List<Dictionary<string, object>> diclist = obj["data"] as List<Dictionary<string, object>>;
            foreach (Dictionary<string, object> dic in diclist)
            {
                //创客
                int UserId = int.Parse(function.CheckInt(dic["UserId"].ToString()));
                Users userid_Users = db.Users.FirstOrDefault(m => m.Id == UserId) ?? new Users();
                dic["UserIdMakerCode"] = userid_Users.MakerCode;
                dic["UserIdRealName"] = userid_Users.RealName;
                dic.Remove("UserId");
                //顶级创客
                int TopUserId = int.Parse(function.CheckInt(dic["TopUserId"].ToString()));
                Users topuserid_Users = db.Users.FirstOrDefault(m => m.Id == TopUserId) ?? new Users();
                dic["TopUserIdMakerCode"] = topuserid_Users.MakerCode;
                dic["TopUserIdRealName"] = topuserid_Users.RealName;
                dic.Remove("TopUserId");
                //状态
                int BlackStatus = int.Parse(dic["BlackStatus"].ToString());
                if (BlackStatus == 1) dic["BlackStatus"] = "有效";
                if (BlackStatus == 0) dic["BlackStatus"] = "无效";

            }
            return Json(obj);
        }

        #endregion

        #region 增加开团黑名单

        /// <summary>
        /// 增加或修改开团黑名单信息
        /// </summary>
        /// <returns></returns>
        public IActionResult Add(string right)
        {
            ViewBag.RightInfo = RightInfo;
            ViewBag.right = right;


            return View();
        }

        #endregion

        #region 增加开团黑名单

        /// <summary>
        /// 增加或修改开团黑名单信息
        /// </summary>
        /// <returns></returns>
        [HttpPost]
        public string Add(TeamBlackList data)
        {
            Dictionary<string, object> Fields = new Dictionary<string, object>();


            Fields.Add("SeoTitle", data.SeoTitle);
            Fields.Add("SeoKeyword", data.SeoKeyword);
            Fields.Add("SeoDescription", data.SeoDescription);
            int Id = new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Add("TeamBlackList", Fields, 0);
            AddSysLog(data.Id.ToString(), "TeamBlackList", "add");
            db.SaveChanges();

            return "success";
        }

        #endregion

        #region 修改开团黑名单

        /// <summary>
        /// 增加或修改开团黑名单信息
        /// </summary>
        /// <returns></returns>
        public IActionResult Edit(string right, int Id = 0)
        {
            ViewBag.RightInfo = RightInfo;
            ViewBag.right = right;


            TeamBlackList editData = db.TeamBlackList.FirstOrDefault(m => m.Id == Id) ?? new TeamBlackList();
            ViewBag.data = editData;
            return View();
        }

        #endregion

        #region 修改开团黑名单

        /// <summary>
        /// 增加或修改开团黑名单信息
        /// </summary>
        /// <returns></returns>
        [HttpPost]
        public string Edit(TeamBlackList data)
        {
            Dictionary<string, object> Fields = new Dictionary<string, object>();


            Fields.Add("SeoTitle", data.SeoTitle);
            Fields.Add("SeoKeyword", data.SeoKeyword);
            Fields.Add("SeoDescription", data.SeoDescription);
            new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Edit("TeamBlackList", Fields, data.Id);
            AddSysLog(data.Id.ToString(), "TeamBlackList", "update");
            db.SaveChanges();

            return "success";
        }

        #endregion

        #region 删除开团黑名单信息

        /// <summary>
        /// 删除开团黑名单信息
        /// </summary>
        /// <returns></returns>
        public string Delete(string Id)
        {
            string[] idlist = Id.Split(new char[] { ',' });
            AddSysLog(Id, "TeamBlackList", "del");
            foreach (string subid in idlist)
            {
                int id = int.Parse(subid);
                Dictionary<string, object> Fields = new Dictionary<string, object>();
                Fields.Add("Status", -1);
                new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Edit("TeamBlackList", Fields, id);
            }
            db.SaveChanges();

            return "success";
        }

        #endregion

        #region 开启

        /// <summary>
        /// 开启
        /// </summary>
        /// <returns></returns>
        public string Open(string Id)
        {
            string[] idlist = Id.Split(new char[] { ',' });
            AddSysLog(Id, "TeamBlackList", "open");
            foreach (string subid in idlist)
            {
                int id = int.Parse(subid);
                Dictionary<string, object> Fields = new Dictionary<string, object>();
                Fields.Add("Status", 1);
                new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Edit("TeamBlackList", Fields, id);
            }
            db.SaveChanges();
            return "success";
        }

        #endregion

        #region 关闭

        /// <summary>
        /// 关闭
        /// </summary>
        /// <returns></returns>
        public string Close(string Id)
        {
            string[] idlist = Id.Split(new char[] { ',' });
            AddSysLog(Id, "TeamBlackList", "close");
            foreach (string subid in idlist)
            {
                int id = int.Parse(subid);
                Dictionary<string, object> Fields = new Dictionary<string, object>();
                Fields.Add("Status", 0);
                new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Edit("TeamBlackList", Fields, id);
            }
            db.SaveChanges();
            return "success";
        }

        #endregion

        #region 排序
        /// <summary>
        /// 排序
        /// </summary>
        /// <param name="Id"></param>
        public string Sort(int Id, int Sort)
        {
            new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Sort("TeamBlackList", Sort, Id);

            AddSysLog(Id.ToString(), "TeamBlackList", "sort");
            return "success";
        }
        #endregion

        #region 导入数据
        /// <summary>
        /// 导入数据
        /// </summary>
        /// <param name="ExcelData"></param>
        public string Import(string ExcelData)
        {
            ExcelData = HttpUtility.UrlDecode(ExcelData);
            JsonData list = JsonMapper.ToObject(ExcelData);
            for (int i = 1; i < list.Count; i++)
            {
                JsonData dr = list[i];

                db.TeamBlackList.Add(new TeamBlackList()
                {
                    CreateDate = DateTime.Now,
                    UpdateDate = DateTime.Now,

                });
                db.SaveChanges();
            }
            AddSysLog("0", "TeamBlackList", "Import");
            return "success";
        }
        #endregion

        #region 导出Excel

        /// <summary>
        /// 导出Excel
        /// </summary>
        /// <returns></returns>
        public JsonResult ExportExcel(TeamBlackList data, string UserIdMakerCode, string UserIdRealName, string TopUserIdMakerCode, string TopUserIdRealName, string BlackStatusSelect)
        {
            Dictionary<string, string> Fields = new Dictionary<string, string>();
            Fields.Add("CreateDate", "3"); //时间
            Fields.Add("EffectStartDate", "3"); //生效时间


            string condition = " and Status>-1";
            //创客编号
            if (!string.IsNullOrEmpty(UserIdMakerCode))
            {
                condition += " and UserId in (select UserId from UserForMakerCode where MakerCode='" + UserIdMakerCode + "')";
            }
            //创客真实姓名
            if (!string.IsNullOrEmpty(UserIdRealName))
            {
                condition += " and UserId in (select UserId from UserForRealName where RealName='" + UserIdRealName + "')";
            }
            //顶级创客编号
            if (!string.IsNullOrEmpty(TopUserIdMakerCode))
            {
                condition += " and TopUserId in (select TopUserId from UserForMakerCode where MakerCode='" + TopUserIdMakerCode + "')";
            }
            //顶级创客真实姓名
            if (!string.IsNullOrEmpty(TopUserIdRealName))
            {
                condition += " and TopUserId in (select TopUserId from UserForRealName where RealName='" + TopUserIdRealName + "')";
            }
            //状态
            if (!string.IsNullOrEmpty(BlackStatusSelect))
            {
                condition += " and BlackStatus=" + BlackStatusSelect;
            }


            Dictionary<string, object> obj = new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).IndexData("TeamBlackList", Fields, "Id desc", "0", 1, 20000, condition, "UserId,EffectStartDate,EffectEndDate,TopUserId,BlackStatus", false);
            List<Dictionary<string, object>> diclist = obj["data"] as List<Dictionary<string, object>>;
            foreach (Dictionary<string, object> dic in diclist)
            {
                //创客
                int UserId = int.Parse(function.CheckInt(dic["UserId"].ToString()));
                Users userid_Users = db.Users.FirstOrDefault(m => m.Id == UserId) ?? new Users();
                dic["UserIdMakerCode"] = userid_Users.MakerCode;
                dic["UserIdRealName"] = userid_Users.RealName;
                dic.Remove("UserId");
                //顶级创客
                int TopUserId = int.Parse(function.CheckInt(dic["TopUserId"].ToString()));
                Users topuserid_Users = db.Users.FirstOrDefault(m => m.Id == TopUserId) ?? new Users();
                dic["TopUserIdMakerCode"] = topuserid_Users.MakerCode;
                dic["TopUserIdRealName"] = topuserid_Users.RealName;
                dic.Remove("TopUserId");
                //状态
                int BlackStatus = int.Parse(dic["BlackStatus"].ToString());
                if (BlackStatus == 1) dic["BlackStatus"] = "有效";
                if (BlackStatus == 0) dic["BlackStatus"] = "无效";

            }

            Dictionary<string, object> result = new Dictionary<string, object>();
            result.Add("Status", "1");
            result.Add("Info", "Excel报表-" + DateTime.Now.ToString("yyyy-MM-ddTHH:mm:ss") + ".xlsx");
            result.Add("Obj", diclist);
            Dictionary<string, object> ReturnFields = new Dictionary<string, object>();
            ReturnFields.Add("UserIdMakerCode", "创客编号");
            ReturnFields.Add("UserIdRealName", "创客姓名");
            ReturnFields.Add("TopUserIdMakerCode", "顶级创客编号");
            ReturnFields.Add("TopUserIdRealName", "顶级创客姓名");
            ReturnFields.Add("EffectStartDate", "生效时间");
            ReturnFields.Add("EffectEndDate", "失效时间");
            ReturnFields.Add("BlackStatus", "状态");
            ReturnFields.Add("CreateDate", "创建时间");

            result.Add("Fields", ReturnFields);
            AddSysLog("0", "TeamBlackList", "ExportExcel");
            return Json(result);
        }

        #endregion

    }
}
